package nl.bartpelle.veteres.content.npcs.pets

import nl.bartpelle.veteres.util.Varbit

/**
 * Created by Bart on 2/18/2016.
 *
 * UPDATE 14/10/2016 : npc_option ID no longer used in Npc Updating. See issue #557
 */

enum class Pet(val item: Int, val npc: Int, val npc_option: Int, val varbit: Int, val metaItemId: Int = -1, val phold: Int = -1) {
	//Boss pets
	ABYSSAL_ORPHAN(13262, 5884, 5883, Varbit.UNLOCKED_PET_ABYSSAL),
	BABY_MOLE(12646, 6635, 6651, Varbit.UNLOCKED_PET_MOLE),
	CALLISTO_CUB(13178, 5558, 497, Varbit.UNLOCKED_PET_CALLISTO),
	HELLPUPPY(13247, 3099, 964, Varbit.UNLOCKED_PET_CERBERUS),
	KALPHITE_PRINCESS(12647, 6638, 6654, Varbit.UNLOCKED_PET_KQ, 12654),
	KALPHITE_PRINCESS_2(12654, 6637, 6653, Varbit.UNLOCKED_PET_KQ, 12647),
	PET_CHAOS_ELEMENTAL(11995, 2055, 5907, Varbit.UNLOCKED_PET_CHAOS_ELE),
	PET_DAGANNOTH_PRIME(12644, 6629, 6627, Varbit.UNLOCKED_PET_DAGANNOTH_PRIME),
	PET_DAGANNOTH_REX(12645, 6630, 6641, Varbit.UNLOCKED_PET_DAGANNOTH_REX),
	PET_DAGGANOTH_SUPREME(12643, 6628, 6626, Varbit.UNLOCKED_PET_DAGANNOTH_SUPREME),
	PET_DARK_CORE(12816, 318, 388, Varbit.UNLOCKED_PET_CORE),
	PET_GENERAL_GRAARDOR(12650, 6632, 6644, Varbit.UNLOCKED_PET_GRAARDOR),
	PET_KRIL_TSUTSAROTH(12652, 6634, 6647, Varbit.UNLOCKED_PET_KRIL),
	PET_KRAKEN(12655, 6640, 6656, Varbit.UNLOCKED_PET_KRAKEN),
	PET_KREEARRA(12649, 6631, 6643, Varbit.UNLOCKED_PET_KREEARRA),
	PET_PENANCE_QUEEN(12703, 6674, 6642, Varbit.UNLOCKED_PET_PENANCE_QUEEN),
	PET_SMOKE_DEVIL(12648, 6639, 6655, Varbit.UNLOCKED_PET_SMOKE_DEVIL),
	PET_SNAKELING_GREEN(12921, 2130, 2127, Varbit.UNLOCKED_PET_ZULRAH, 12939),
	PET_SNAKELING_RED(12939, 2131, 2128, Varbit.UNLOCKED_PET_ZULRAH, 12940),
	PET_SNAKELING_BLUE(12940, 2132, 2129, Varbit.UNLOCKED_PET_ZULRAH, 12921),
	PET_ZILYANA(12651, 6633, 6646, Varbit.UNLOCKED_PET_ZILYANA),
	PRINCE_BLACK_DRAGON(12653, 6636, 6652, Varbit.UNLOCKED_PET_KBD),
	SCORPIAS_OFFSPRING(13181, 5561, 5547, Varbit.UNLOCKED_PET_SCORPIA),
	TZREK_JAD(13225, 5893, 5892, Varbit.UNLOCKED_PET_JAD),
	JAL_NIB_REK(21291, 7675, 7674, Varbit.UNLOCKED_JAL_NIB), //TODO get the remaining VARBIT
	VENENATIS_SPIDERLING(13177, 5557, 495, Varbit.UNLOCKED_PET_VENENATIS),
	VETION_JR_PURPLE(13179, 5559, 5536, Varbit.UNLOCKED_PET_VETION_PURPLE, 13180),
	VETION_JR_ORANGE(13180, 5560, 5537, Varbit.UNLOCKED_PET_VETION_PURPLE, 13179),
	NOON(21748, 7892, 7891, Varbit.UNLOCKED_PET_NOON, 21750),
	MIDNIGHT(21750, 7893, 7890, Varbit.UNLOCKED_PET_NOON, 21748),
	
	//Skilling pets
	BABY_CHINCHOMPA_BLACK(13325, 6758, 6720, Varbit.UNLOCKED_PET_CHINCHOMPA, 13324),
	BABY_CHINCHOMPA_GREY(13324, 6757, 6719, Varbit.UNLOCKED_PET_CHINCHOMPA, 13323),
	BABY_CHINCHOMPA_RED(13323, 6756, 6718, Varbit.UNLOCKED_PET_CHINCHOMPA, 13325),
	BABY_CHINCHOMPA_YELLOW(13326, 6759, 6721, Varbit.UNLOCKED_PET_CHINCHOMPA, 13324),
	BEAVER(13322, 6724, 6717, Varbit.UNLOCKED_PET_BEAVER, phold = 15342),
	HERON(13320, 6722, 6715, Varbit.UNLOCKED_PET_HERON, phold = 15340),
	ROCK_GOLEM(13321, 7451, -1, Varbit.UNLOCKED_PET_GOLEM, phold = 15341),
	GIANT_SQUIRREL(20659, 7351, 7334, Varbit.UNLOCK_PET_GIANT_SQUIRREL, phold = 20660),
	TANGLEROOT(20661, 7352, 7335, Varbit.UNLOCK_PET_TANGLEROOT, phold = 20662),
	ROCKY(20663, 7353, 7336, Varbit.UNLOCKED_PET_ROCKY, phold = 20664),
	RIFT_GUARDIAN_FIRE(20665, 7354, 7337, Varbit.UNLOCK_PET_RIFT_GUARDIAN),
	RIFT_GUARDIAN_AIR(20667, 7355, 7338, Varbit.UNLOCK_PET_RIFT_GUARDIAN, phold = 20668),
	RIFT_GUARDIAN_MIND(20669, 7356, 7339, Varbit.UNLOCK_PET_RIFT_GUARDIAN),
	RIFT_GUARDIAN_WATER(20671, 7357, 7340, Varbit.UNLOCK_PET_RIFT_GUARDIAN),
	RIFT_GUARDIAN_EARTH(20673, 7358, 7341, Varbit.UNLOCK_PET_RIFT_GUARDIAN),
	RIFT_GUARDIAN_BODY(20675, 7359, 7342, Varbit.UNLOCK_PET_RIFT_GUARDIAN),
	RIFT_GUARDIAN_COSMIC(20677, 7360, 7343, Varbit.UNLOCK_PET_RIFT_GUARDIAN),
	RIFT_GUARDIAN_CHAOS(20679, 7361, 7344, Varbit.UNLOCK_PET_RIFT_GUARDIAN),
	RIFT_GUARDIAN_NATURE(20681, 7362, 7345, Varbit.UNLOCK_PET_RIFT_GUARDIAN),
	RIFT_GUARDIAN_LAW(20683, 7363, 7346, Varbit.UNLOCK_PET_RIFT_GUARDIAN),
	RIFT_GUARDIAN_DEATH(20685, 7364, 7347, Varbit.UNLOCK_PET_RIFT_GUARDIAN),
	RIFT_GUARDIAN_SOUL(20687, 7365, 7348, Varbit.UNLOCK_PET_RIFT_GUARDIAN),
	RIFT_GUARDIAN_ASTRAL(20689, 7366, 7349, Varbit.UNLOCK_PET_RIFT_GUARDIAN),
	RIFT_GUARDIAN_BLOOD(20691, 7367, 7350, Varbit.UNLOCK_PET_RIFT_GUARDIAN),
	HERBI(21509, 7760, 7759, Varbit.UNLOCKED_PET_HERBI),
	SKOTOS(21273, 7671, 425, Varbit.UNLOCKED_PET_SKOTOS),
	VORKI(21992, 8029, 8025, Varbit.UNLOCKED_PET_VORKI),
	
	// Other types of pets. Skilling boss & misc.
	BLOODHOUND(19730, 7232, 6296, Varbit.UNLOCK_PET_BLOODHOUND, phold = 19731),
	CHOMPY_CHICK(13071, 4002, 4001, Varbit.UNLOCKED_PET_CHOMPY, phold = 15305),
	PHOENIX(20693, 7370, 7368, Varbit.UNLOCK_PET_PHOENIX, phold = 20694),
	OLMLET(20851, 7520, 7519, Varbit.UNLOCK_PET_OLMLET, phold = 20852),

	// Hellcats do not have varbits for unlocking by Probita. These are NOT for players, for admin use only.
	HELLCAT(7582, 1625, -1, 1_000_000),
	LAZY_HELLCAT(7584, 1632, -1, 1_000_000),
	WILY_HELLCAT(7585, 5590, -1, 1_000_000),
	OVERGROWN_HELLCAT(7581, 5604, -1, 1_000_000),
	HELLKITTEN(7583, 5597, -1, 1_000_000)

	;
	
	companion object {
		
		val MAP_BY_NPC = values().map { pet -> Pair(pet.npc_option, pet) }.toMap() +
				values().map { pet -> Pair(pet.npc, pet) }.toMap()
		
		
		@JvmStatic fun getByNpc(npc: Int): Pet? {
			return MAP_BY_NPC[npc]
		}
		
		@JvmStatic fun getPetByItem(item: Int): Pet? {
			for (pet in values()) {
				if (pet.item == item) {
					return pet
				}
			}
			
			return null
		}
	}
}